Attribute VB_Name = "modCount"
Option Explicit

Public gsProjectPath As String
Public gdTotalCount As Double
Public gbIncludeComments As Boolean
Public gbReportDetails As Boolean
Public gbReportZero As Boolean
Public gsProject As String
Public gbQuit As Boolean
Public gbPrint As Boolean
Public gnPageNumber As Integer
Public gnCurrPage As Integer
Public gsAppDBPath As String
Public gdbStoreData As Database
Public gnReportLineNumber As Integer
Public gbBold As Boolean
Public gbUnderline As Boolean
Public gnModuleType As Integer
Public Const DSW = 1
Public Const DSP = 2
Public Const VBP = 3
Public Const COL2 = 5
Public Const COL3 = 70

'******* 01.01.01 Misc #2 Start *******
Public gsIniName As String              'Name of the Application's INI file
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'******* 01.01.01 Misc #2 End *********

Public Sub GetAppEnvironment()

    '******* 01.01.01 Misc #2 Start *******
    Dim sBuffer As String
    Dim nDummy As Integer
    Dim nCommaPos As Integer
    Dim nStartPos As Integer
    Dim sWork As String
    Dim bDone As Boolean
    Dim nEndPos As Integer
    
    gsIniName = App.Path & "\" & App.EXEName & ".INI"
    
    sBuffer = Space$(99)
    nDummy = GetPrivateProfileString("Options", "Filters", "", sBuffer, 99, gsIniName)
    sWork = Left$(sBuffer, nDummy)
    nStartPos = 1
    
    If Len(sWork) > 0 Then
        Do Until bDone
            nCommaPos = InStr(nStartPos, sWork, ",")
            If nCommaPos > 0 Then
                frmExtension.lstExtensions.AddItem Mid(sWork, nStartPos, nCommaPos - nEndPos - 1)
                nStartPos = nCommaPos + 1
                nEndPos = nCommaPos
            Else
                bDone = True
                frmExtension.lstExtensions.AddItem Mid(sWork, nStartPos, Len(sWork) - nStartPos + 1)
            End If
        Loop
    Else
         frmExtension.lstExtensions.AddItem "BMP"
    End If
    
    CheckLength
    '******* 01.01.01 Misc #2 End *********

End Sub
Public Sub CheckLength()

    '******* 01.01.01 Misc #2 Start *******
    If frmExtension.lstExtensions.ListCount > 4 Then
        frmExtension.lstExtensions.Width = 810
        frmExtension.lstExtensions.Left = frmExtension.cmdAdd.Left - 855 - 225
    Else
        frmExtension.lstExtensions.Width = 585
        frmExtension.lstExtensions.Left = frmExtension.cmdAdd.Left - 855
    End If
    '******* 01.01.01 Misc #2 End *********

End Sub

Public Sub PrintFontName(sFontName As String)
'***************************************************************************
'Purpose: Set [printobject].FontName
'Inputs:  sFontName - Name of font to be used in printing
'Outputs: None
'***************************************************************************
    'Dim I   ' Declare variable.

    'For I = 0 To Printer.FontCount - 1  ' Determine number of fonts.
        'List1.AddItem Printer.Fonts(I) ' Put each font into list box.
        'If Printer.Fonts(I) = sFontName Then
            'MsgBox "Found " & sFontName
        'End If
    'Next I

    Select Case gbPrint
        Case True
            Printer.Font.Name = sFontName
        Case False
            frmResults.picPreview(0).Font.Name = sFontName
    End Select


End Sub

Public Sub LoadNewPicture()
'***************************************************************************
'Purpose: The number of report pages that need to be displayed is variable
'         and each one is displayed in a seperate instance of picPreview.
'         This routine creates the instances as needed.
'Outputs: None
'***************************************************************************
    
    On Error GoTo ErrorRoutine
    
    gnPageNumber = gnPageNumber + 1
    Load frmResults.picPreview(gnPageNumber)
    frmResults.picPreview(gnPageNumber).ScaleHeight = Printer.ScaleHeight
    
    frmResults.cmdNextPage.Enabled = True
    
    Exit Sub
ErrorRoutine:
    If Err.Number = 360 Then
        Resume Next
    End If

End Sub

Public Sub CountLinesVBP()

    Dim sLine As String
    Dim dProcedureCount As Double
    Dim dModuleCount As Double
    Dim sProcedureName As String
    Dim nPos As Integer
    Dim nModuleIndex As Integer
    Dim bForm As Boolean
    Dim bOK As Boolean
    Dim rsReport As Recordset
    Dim sTitle As String
    Dim sMsg As String
    Dim nStyle As Integer
    Dim bModNamePrinted As Boolean
    
    On Error GoTo ErrorRoutine
    
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)

    Const QUOTE = "'"
    Const LeftBracket = "("
    
    PrintHeading rsReport
    
    For nModuleIndex = 0 To frmProject.lstModules.ListCount - 1
        If gbQuit Then
            rsReport.Close
            Exit Sub
        End If
        bModNamePrinted = False
        If frmProject.lstModules.Selected(nModuleIndex) Then
            frmProject.lstModules.ListIndex = nModuleIndex
            If UCase(Right(frmProject.lstModules.Text, 3)) = "FRM" Then
                bForm = True
            Else
                bForm = False
            End If
            frmProject.cmdQuit.Enabled = True
            bOK = False
            dProcedureCount = 0
            dModuleCount = 0
            sProcedureName = "Declarations"
            Open gsProjectPath & frmProject.lstModules.Text For Input As #2
            frmProject.lblCounting.Caption = "Counting " & frmProject.lstModules.Text & "..."
            DoEvents
            Do Until EOF(2)
                Line Input #2, sLine
                sLine = LTrim(sLine)
                Select Case True
                    Case Len(sLine) = 0, _
                         InStr(sLine, "End Sub"), _
                         InStr(sLine, "End Function")
                        'Ignore all the above
                    Case Left(sLine, 10) = "Attribute " 'Ignore Attribute lines
                        'If we are counting the lines in a form we have to
                        'bypass a lot of internal stuff that describes the
                        'form and its controls. The end of this stuff is just
                        'before the first "Attribute" line. We set this flag
                        'here to indicate that it is OK (below) to start
                        'counting lines in the form
                        If bForm Then bOK = True
                    Case Left(sLine, 1) = QUOTE
                        'Count comment lines if that option is chosen
                        If gbIncludeComments Then
                            If bForm Then
                                If bOK Then
                                    dProcedureCount = dProcedureCount + 1
                                    dModuleCount = dModuleCount + 1
                                    gdTotalCount = gdTotalCount + 1
                                End If
                            Else
                                dProcedureCount = dProcedureCount + 1
                                dModuleCount = dModuleCount + 1
                                gdTotalCount = gdTotalCount + 1
                            End If
                        End If
                    Case Else
                        If Left(sLine, 4) = "Sub " Or _
                           Left(sLine, 11) = "Public Sub " Or _
                           Left(sLine, 12) = "Private Sub " Or _
                           Left(sLine, 9) = "Function " Or _
                           Left(sLine, 16) = "Public Function " Or _
                           Left(sLine, 17) = "Private Function " Then
                            'Its the start of a new procedure so write
                            'stats for old procedure...
                             bModNamePrinted = WriteProcedureStats(rsReport, bModNamePrinted, sProcedureName, dModuleCount, dProcedureCount)
                            '...and save the name of the new procedure
                            nPos = InStr(sLine, LeftBracket)
                            sProcedureName = Left(sLine, nPos - 1)
                            dProcedureCount = 0
                        Else
                            If bForm Then
                                If bOK Then
                                    dProcedureCount = dProcedureCount + 1
                                    dModuleCount = dModuleCount + 1
                                    gdTotalCount = gdTotalCount + 1
                                End If
                            Else
                                dProcedureCount = dProcedureCount + 1
                                dModuleCount = dModuleCount + 1
                                gdTotalCount = gdTotalCount + 1
                            End If
                        End If
                End Select
            Loop
            
            If gbReportDetails Then
                bModNamePrinted = WriteProcedureStats(rsReport, bModNamePrinted, sProcedureName, dModuleCount, dProcedureCount)
            End If
            bModNamePrinted = WriteModuleStats(rsReport, bModNamePrinted, sProcedureName, dProcedureCount, dModuleCount)
            
            Close #2
        End If
    Next
    
    PrintFinish rsReport
    
    rsReport.Close
    Exit Sub
    
ErrorRoutine:
    If Err.Number = 53 Then
        sMsg = "File " & gsProjectPath & frmProject.lstModules.Text & " not found"
        sTitle = "File Open Error"
        nStyle = vbCritical
        MsgBox sMsg, nStyle, sTitle
        frmProject.lstModules.Selected(nModuleIndex) = False
        Exit Sub
    End If

End Sub

Public Sub ProcessDSP()

    Dim nPos As Integer
    Dim nModuleIndex As Integer
    Dim rsReport As Recordset
    Dim sMsg As String
    Dim dModuleCount As Double
    Dim nResponse As Integer
    Dim bDummy As Boolean
    
    On Error GoTo ErrorRoutine
    
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)

    PrintHeading rsReport

    For nModuleIndex = 0 To frmProject.lstModules.ListCount - 1
        If gbQuit Then
            rsReport.Close
            Exit Sub
        End If
        bDummy = True
        If frmProject.lstModules.Selected(nModuleIndex) Then
            frmProject.lstModules.ListIndex = nModuleIndex
            frmProject.cmdQuit.Enabled = True
            dModuleCount = CountLinesC(frmProject.lstModules.Text)
            bDummy = WriteProcedureStats(rsReport, bDummy, frmProject.lstModules.Text, dModuleCount, dModuleCount)
'            PrintPrint frmProject.lstModules.Text & ";"
'            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
'                       frmProject.lstModules.Text & ";"
'            PrintPrint "", COL3, dModuleCount
'            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
'                       "", COL3, dModuleCount
        End If
        
SkipFile:
    Next
        
    PrintFinish rsReport
    
    rsReport.Close
    Exit Sub
    
ErrorRoutine:
    If Err.Number = 53 Or Err.Number = 76 Then
        Beep
        Beep
        sMsg = "File " & gsProjectPath & frmProject.lstModules.Text & " not found." _
             & vbCrLf & vbCrLf _
             & "Press OK to ignore the missing file and continue counting."
        nResponse = MsgBox(sMsg, vbCritical + vbOKCancel, "Missing File")
        frmProject.lstModules.Selected(nModuleIndex) = False
        If nResponse = vbCancel Then
            Exit Sub
        Else
            Resume SkipFile
        End If
    Else
        DisplayError "ProcessDSP"
    End If

End Sub
Public Sub DisplayError(sRoutine As String)
'***************************************************************************
'Purpose: Common error display routine
'Inputs:  None
'Outputs: None
'***************************************************************************

    Beep
    Beep
    
    MsgBox "Error #" _
         & Str(Err.Number) _
         & " was generated by " _
         & Err.Source _
         & " in routine " _
         & sRoutine & "." _
         & vbCrLf & vbCrLf & Err.Description
'                MsgBox ResolveResString(resDISPLAYERROR, _
'                "|1", Str(Err.Number), _
'                "|2", Err.Source, _
'                "|3", sRoutine, _
'                "|4", vbCrLf & vbCrLf & Err.Description) _
'                , , ResolveResString(resDISPLAYERRORTITLE), Err.HelpFile, Err.HelpContext

End Sub

Public Function GetModulesVBP()

    Dim sLine As String
    Dim nPos As Integer
    Dim bFirstLine As Boolean
    Const SEMICOLON = ";"
    Const EQUALSIGN = "="

    On Error GoTo ErrorRoutine
    
    frmProject.lstModules.Clear
    
    gsProjectPath = frmProject.dlgProject.filename
    For nPos = Len(frmProject.dlgProject.filename) To 0 Step -1
        If Right(gsProjectPath, 1) = "\" Then
            Exit For
        End If
        gsProjectPath = Left(gsProjectPath, Len(gsProjectPath) - 1)
    Next
    
    bFirstLine = True
    Open frmProject.dlgProject.filename For Input As #1
        Do Until EOF(1)
        Line Input #1, sLine
        sLine = LTrim(sLine)
        If bFirstLine Then
            bFirstLine = False
            If Left(sLine, 5) <> "Type=" Then
                Err.Raise 9999
            End If
        End If
        Select Case True
            Case InStr(sLine, "Form=")
                If Left(sLine, 4) <> "Icon" Then 'Ignore IconForm
                    nPos = InStr(sLine, EQUALSIGN)
                    frmProject.lstModules.AddItem UCase(Right(sLine, Len(sLine) - nPos))
                End If
            Case InStr(sLine, "Module=")
                nPos = InStr(sLine, SEMICOLON) + 1
                frmProject.lstModules.AddItem UCase(Right(sLine, Len(sLine) - nPos))
            Case InStr(sLine, "Title=")
                gsProject = Mid(sLine, 8, Len(sLine) - 8)
                frmProject.lblModules.Caption = "Modules In " & gsProject
                
        End Select
    Loop
    
    frmProject.tbarProject.Buttons(5).Enabled = True
    frmProject.tbarProject.Buttons(6).Enabled = True
    Close #1
    GetModulesVBP = True
    Exit Function
    
ErrorRoutine:
    'If Err.Number = 53 Then
        Beep
        Beep
        MsgBox "Not a VB5 project file", vbCritical, "Invalid File Type"
        Close #1
        GetModulesVBP = False
    'End If

End Function
Public Function GetModulesDSW()

    Dim sLine As String
    Dim nPos As Integer
    Dim bFirstLine As Boolean
    Dim sWork As String
    
    On Error GoTo ErrorRoutine
    
    frmProject.lstModules.Clear
    
    gsProjectPath = frmProject.dlgProject.filename
    For nPos = Len(frmProject.dlgProject.filename) To 0 Step -1
        If Right(gsProjectPath, 1) = "\" Then
            'gsProject = Right(frmProject.dlgProject.filename, nPos)
            gsProject = Mid(frmProject.dlgProject.filename, nPos + 1, Len(frmProject.dlgProject.filename))
            
            frmProject.lblModules.Caption = "Projects In " & gsProject
            Exit For
        End If
        gsProjectPath = Left(gsProjectPath, Len(gsProjectPath) - 1)
    Next
    
    bFirstLine = True
    
    frmProject.lstModules.Clear
    Open frmProject.dlgProject.filename For Input As #1
        Do Until EOF(1)
        Line Input #1, sLine
        sLine = LTrim(sLine)
        If bFirstLine Then
            bFirstLine = False
            If Left(sLine, 62) <> "Microsoft Developer Studio Workspace File, Format Version 5.00" Then
                Err.Raise 9999
            End If
        End If
        Select Case True
            Case InStr(sLine, "Project:")
                nPos = InStr(sLine, "=.")
                sWork = Right(sLine, Len(sLine) - nPos - 2)
                nPos = InStr(sWork, " - Package Owner")
                sWork = Mid(sWork, 1, nPos)
                frmProject.lstModules.AddItem UCase(sWork)
        End Select
    Loop
    
    Close #1
    frmProject.tbarProject.Buttons(5).Enabled = True
    frmProject.tbarProject.Buttons(6).Enabled = True
    GetModulesDSW = True
    Exit Function
    
ErrorRoutine:
    Beep
    Beep
    MsgBox "Not a recognized Microsoft Developer Studio Workspace File", vbCritical, "Invalid File Type"
    Close #1
    GetModulesDSW = False

End Function

Public Function GetModulesDSP()

    Dim sLine As String
    Dim nPos As Integer
    Dim bFirstLine As Boolean
    Dim bSecondLine As Boolean
    Dim sWork As String
    Dim sFileType As String
    Dim nIndex As Integer
    Dim bFound As Boolean
    
    On Error GoTo ErrorRoutine
    
    frmProject.lstModules.Clear
    
    gsProjectPath = frmProject.dlgProject.filename
    For nPos = Len(frmProject.dlgProject.filename) To 0 Step -1
        If Right(gsProjectPath, 1) = "\" Then
            gsProject = Mid(frmProject.dlgProject.filename, nPos + 1, Len(frmProject.dlgProject.filename))
            frmProject.lblModules.Caption = "Modules In " & gsProject
            Exit For
        End If
        gsProjectPath = Left(gsProjectPath, Len(gsProjectPath) - 1)
    Next
    
    bFirstLine = True
    
    frmProject.lstModules.Clear
    Open frmProject.dlgProject.filename For Input As #1
        Do Until EOF(1)
        Line Input #1, sLine
        sLine = LTrim(sLine)
        If bSecondLine Then
            bSecondLine = False
            If Left(sLine, 70) <> "# Microsoft Developer Studio Generated Build File, Format Version 5.00" Then
                Err.Raise 9999
            End If
        End If
        If bFirstLine Then
            bFirstLine = False
            bSecondLine = True
        End If
        If Left(sLine, 9) = "SOURCE=.\" Then
            '******* 01.01.01 Misc #2 Start *******
'            frmProject.lstModules.AddItem UCase(Right(sLine, Len(sLine) - 9))
            sFileType = UCase(GetExtension(sLine))
            bFound = False
            For nIndex = 0 To frmExtension.lstExtensions.ListCount - 1
                If sFileType = frmExtension.lstExtensions.List(nIndex) Then
                    bFound = True
                    Exit For
                End If
            Next
            If Not bFound Then
                frmProject.lstModules.AddItem UCase(Right(sLine, Len(sLine) - 9))
            End If
            '******* 01.01.01 Misc #2 End *********
        End If
    Loop
    
    Close #1
    frmProject.tbarProject.Buttons(5).Enabled = True
    frmProject.tbarProject.Buttons(6).Enabled = True
    GetModulesDSP = True
    Exit Function
    
ErrorRoutine:
    Beep
    Beep
    MsgBox "Not a recognized Microsoft Developer Studio Project File", vbCritical, "Invalid File Type"
    Close #1
    GetModulesDSP = False

End Function

Public Function GetAllModulesDSP(sName As String)

    Dim sLine As String
    Dim nPos As Integer
    Dim bFirstLine As Boolean
    Dim bSecondLine As Boolean
    Dim sModName As String
    Dim sFileType As String
    Dim nFileIndex As Integer
    Dim sCPPFolder As String
    
    Const SLASH = "\"
    
    On Error GoTo ErrorRoutine
    
    bFirstLine = True
    
    '******* 01.01.01 Misc #1 Start *******
'    sCPPFolder = sName
'    For nPos = Len(sName) To 0 Step -1
'        If Right(sCPPFolder, 1) = SLASH Then
'            Exit For
'        End If
'        sCPPFolder = Left(sCPPFolder, Len(sCPPFolder) - 1)
'    Next
    If InStr(1, sName, SLASH) > 0 Then
        sCPPFolder = sName
        For nPos = Len(sName) To 0 Step -1
            If Right(sCPPFolder, 1) = SLASH Then
                Exit For
            End If
            sCPPFolder = Left(sCPPFolder, Len(sCPPFolder) - 1)
        Next
    Else
        sCPPFolder = ""
    End If
    '******* 01.01.01 Misc #1 End *********
    
    Open sName For Input As #1
        Do Until EOF(1)
        Line Input #1, sLine
        sLine = LTrim(sLine)
        If bSecondLine Then
            bSecondLine = False
            If Left(sLine, 70) <> "# Microsoft Developer Studio Generated Build File, Format Version 5.00" Then
                Err.Raise 9999
            End If
        End If
        If bFirstLine Then
            bFirstLine = False
            bSecondLine = True
        End If
        If Left(sLine, 9) = "SOURCE=.\" Then
            sModName = UCase(Right(sLine, Len(sLine) - 9))
            'Determine the file type of the current module.
            '******* 01.01.01 Misc #2 Start *******
'            sFileType = ""
'            For nPos = Len(sModName) To 1 Step -1
'                If Mid(sModName, nPos, 1) = "." Then
'                    Exit For
'                Else
'                    sFileType = Mid(sModName, nPos, 1) & sFileType
'                End If
'            Next
            sFileType = GetExtension(sModName)
            '******* 01.01.01 Misc #2 End *********
            'See if the file type is selected in the file type list.
            For nFileIndex = 0 To frmFiles.lstFileType.ListCount - 1
                If sFileType = UCase(frmFiles.lstFileType.List(nFileIndex)) Then
                    If frmFiles.lstFileType.Selected(nFileIndex) Then
                        'It is, so add the module name to the lstAllDSPMod
                        '(invisible) list. This list substitutes for an
                        'internal table.
                        frmProject.lstAllDSPMod.AddItem sCPPFolder & sModName
                    End If
                    Exit For
                End If
            Next
        End If
    Loop
    
    Close #1
    GetAllModulesDSP = True
    Exit Function
    
ErrorRoutine:
    Beep
    Beep
    MsgBox sName & " Is not a recognized Microsoft Developer Studio Project File", vbCritical, "Invalid File Type"
    Close #1
    GetAllModulesDSP = False

End Function

Public Sub OpenDB()

    Dim rsReport As Recordset
    
    'On Error GoTo ErrorRoutine
    
    gsAppDBPath = App.Path + "\CountLines.mdb"
    Set gdbStoreData = Workspaces(0).OpenDatabase(gsAppDBPath)
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)
    
    DeleteOldReport
    
End Sub

Function PrintPrint(ParamArray PrintData()) As Boolean
'***************************************************************************
'Purpose: Print a line
'Inputs:  PrintData which contains a variable number of parameters. They
'         are of the form:
'             text, tab-position, text, tab-position,...
'Outputs: None
'***************************************************************************

    Dim nCtr As Integer
    Dim bPageNumberPrinted As Boolean
    Dim rsReport As Recordset
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)
    
    Select Case gbPrint
        Case True
            For nCtr = 0 To UBound(PrintData)
                If nCtr < UBound(PrintData) Then
                    Printer.Print PrintData(nCtr);
                    nCtr = nCtr + 1
                    'Printer.Print Tab(PrintData(nCtr));
                    Printer.CurrentX = Printer.Width * (PrintData(nCtr) / 110)
                Else
                    'Allow the next input to be printed on the same line
                    If Right(PrintData(nCtr), 1) = ";" Then
                        'Remove the trailing semicolon
                        PrintData(nCtr) = Left(PrintData(nCtr), Len(PrintData(nCtr)) - 1)
                        Printer.Print PrintData(nCtr);
                    Else
                        Printer.Print PrintData(nCtr)
                    End If
                End If
            Next
        Case False
            bPageNumberPrinted = False
            If frmResults.picPreview(gnPageNumber).CurrentY + 300 > Printer.ScaleHeight Then
                PrintRightJustify (" Page " & gnPageNumber + 1)
                frmResults.picPreview(gnPageNumber).Print " Page " & gnPageNumber + 1
                StoreReportLine rsReport, False, False, True, True, _
                            " Page " & gnPageNumber + 1
                frmResults.picPreview(gnPageNumber).Height = _
                        frmResults.picPreview(gnPageNumber).CurrentY + 300
                bPageNumberPrinted = True
                LoadNewPicture
            End If
            For nCtr = 0 To UBound(PrintData)
                If nCtr < UBound(PrintData) Then
                    frmResults.picPreview(gnPageNumber).Print PrintData(nCtr);
                    nCtr = nCtr + 1
                    frmResults.picPreview(gnPageNumber).CurrentX = _
                        frmResults.picPreview(gnPageNumber).Width * (PrintData(nCtr) / 110)
                'Its the last value in PrintData
                Else
                    'Allow the next input to be printed on the same line
                    If Right(PrintData(nCtr), 1) = ";" Then
                        'Remove the trailing semicolon
                        PrintData(nCtr) = Left(PrintData(nCtr), Len(PrintData(nCtr)) - 1)
                        frmResults.picPreview(gnPageNumber).Print PrintData(nCtr);
                    Else
                        'This is the place where every line ends
                        frmResults.picPreview(gnPageNumber).Print PrintData(nCtr)
                    End If
                End If
            Next
    End Select
    
    PrintPrint = bPageNumberPrinted

End Function
Public Function PrintRightJustify(sText As String)
'***************************************************************************
'Purpose: Set the starting print position of text that is going to be
'         right justified
'Inputs:  Length of text string that is going to be printed
'Outputs: [printobject].CurrentX
'***************************************************************************

    Dim nTextLen As Integer
    
    Select Case gbPrint
        Case True
            Printer.CurrentX = Printer.ScaleWidth - Printer.TextWidth(sText)
            nTextLen = Printer.TextWidth(sText)
        Case False
            frmResults.picPreview(gnPageNumber).CurrentX = frmResults.picPreview(gnPageNumber).ScaleWidth - _
                frmResults.picPreview(gnPageNumber).TextWidth(sText) - 60
            nTextLen = frmResults.picPreview(gnPageNumber).TextWidth(sText)
    End Select

    PrintRightJustify = nTextLen
    
End Function


Public Sub PrintFontBold(bTruefalse As Boolean)
'***************************************************************************
'Purpose: Set [printobject].FontBold
'Inputs:  bTrueFalse - Boolean indicating if bold should be turned on or off
'Outputs: None
'***************************************************************************

    Select Case gbPrint
        Case True
            Printer.Font.Bold = bTruefalse
        Case False
            frmResults.picPreview(gnPageNumber).Font.Bold = bTruefalse
            gbBold = bTruefalse
    End Select
            
End Sub
Public Sub PrintFontUnderline(bTruefalse As Boolean)
'***************************************************************************
'Purpose: Set [printobject].FontUnderline
'Inputs:  bTrueFalse - Boolean indicating if underlining should be turned on
'                      or off
'Outputs: None
'***************************************************************************

    Select Case gbPrint
        Case True
            Printer.Font.Underline = bTruefalse
        Case False
            frmResults.picPreview(gnPageNumber).Font.Underline = bTruefalse
            gbUnderline = bTruefalse
    End Select

End Sub

Public Sub PrintFontSize(nFontSize As Integer)
'***************************************************************************
'Purpose: Set [printobject].FontSize
'Inputs:  nFontSize - Size of font to be used in printing
'Outputs: None
'***************************************************************************

    Dim fNewSize As Single
    Dim nSM As Integer
    Dim fWidthRation As Single
    
    If Not gbPrint Then
        nSM = frmResults.picPreview(gnPageNumber).ScaleMode
        frmResults.picPreview(gnPageNumber).ScaleMode = 5 'inches
        Printer.ScaleMode = 5 'inches
        fWidthRation = frmResults.picPreview(gnPageNumber).ScaleWidth / Printer.ScaleWidth '8.5
        Printer.ScaleMode = 1
        frmResults.picPreview(gnPageNumber).ScaleMode = nSM
    End If
    
    Select Case gbPrint
        Case True
            Printer.Font.Size = nFontSize
        Case False
            'When the font size gets too small, Windows switches to
            '"Small Fonts" which is a crude font. The following "If" resets
            'it so that "Small Fonts" is only used when needed
            If frmResults.picPreview(gnPageNumber).Font.Name = "Small Fonts" Then
                frmResults.picPreview(gnPageNumber).Font.Size = 8.25
                frmResults.picPreview(gnPageNumber).Font.Name = "Arial"
            End If
            
            'fNewSize = nFontSize * fWidthRation * gfXFactor
            fNewSize = nFontSize * fWidthRation
            
            'If fNewSize < 7 Then fNewSize = 7 'Anything smaller is hard to read
            If fNewSize < 8.25 Then
                fNewSize = 8.25 'Anything smaller is hard to read
                frmResults.picPreview(gnPageNumber).Font.Name = "Arial"
                frmResults.picPreview(gnPageNumber).Font.Size = fNewSize
            End If
    End Select
    
End Sub

Public Function StripAmpersand(sCaption As String)

    Dim nPos As Integer
    Const AMPERSAND = "&"
    
    nPos = InStr(sCaption, AMPERSAND)
    StripAmpersand = Left(sCaption, nPos - 1) & Right(sCaption, Len(sCaption) - nPos)

End Function

Public Function YesNo(bChecked As Boolean)

    Const YES = "Yes"
    Const NO = "No"
    
    If bChecked Then
        YesNo = YES
    Else
        YesNo = NO
    End If

End Function

Public Sub SelectAllModules(bTruefalse As Boolean)

    Dim nCount As Integer
    
    For nCount = 0 To frmProject.lstModules.ListCount - 1
        frmProject.lstModules.Selected(nCount) = bTruefalse
    Next
    
    frmProject.lstModules.ListIndex = 0
    
    If bTruefalse Then
        frmProject.tbarProject.Buttons(5).Value = tbrPressed
    Else
        frmProject.tbarProject.Buttons(6).Value = tbrPressed
    End If

End Sub

Public Function StoreReportLine(RS As Recordset, bBold As Boolean, bUnderline As Boolean, bRightJustify As Boolean, bPageBreak As Boolean, sLinePart1 As String, Optional nTab1, Optional sLinePart2, Optional nTab2, Optional sLinePart3)

    gnReportLineNumber = gnReportLineNumber + 1
    
    RS.AddNew
    RS.ReportLineNumber = gnReportLineNumber
    If sLinePart1 = "" Then sLinePart1 = " "
    RS.linepart1 = sLinePart1
    If Not IsMissing(nTab1) Then
        RS.Tab1 = nTab1
    End If
    If Not IsMissing(sLinePart2) Then
        RS.linepart2 = sLinePart2
    End If
    If Not IsMissing(nTab2) Then
        RS.Tab2 = nTab2
    End If
    If Not IsMissing(sLinePart3) Then
        RS.Linepart3 = sLinePart3
    End If
    RS.Bold = bBold
    RS.Underline = bUnderline
    RS.RightJustify = bRightJustify
    RS.PageNumber = gnPageNumber + 1
    RS.PageBreak = bPageBreak
    RS.Update

End Function

Public Sub PrintReport(nFromPage As Integer, nToPage As Integer)

    Dim bPrintedFirstLine As Boolean
    Dim bOldBold As Boolean
    Dim bOldUnderline As Boolean
    Dim bPageBreak As Boolean
    Dim sPart1 As String
    
    'On Error GoTo ErrorRoutine

    Dim ssReportRecords As Snapshot
    
    Set ssReportRecords = gdbStoreData.CreateSnapshot("Select * From Report order by ReportLineNumber")
    
    Do Until ssReportRecords.EOF
        If ssReportRecords.PageNumber >= nFromPage Then
            If ssReportRecords.PageNumber > nToPage Then
                Printer.EndDoc
                ssReportRecords.Close
            End If
            
            If ssReportRecords.linepart1 = " " Then
                sPart1 = ""
            Else
                sPart1 = ssReportRecords.linepart1
            End If
    '        If bPrintedFirstLine Then
    '            If ssReportRecords.Bold <> bOldBold Then
    '                PrintFontBold ssReportRecords.Bold
    '            End If
    '            If ssReportRecords.Underline <> bOldUnderline Then
    '                PrintFontUnderline ssReportRecords.Underline
    '            End If
    '        Else
    '            PrintFontBold ssReportRecords.Bold
    '            PrintFontUnderline ssReportRecords.Underline
    '        End If
    
    '        Select Case ssReportRecords.Bold
    '            Case True
    '                PrintFontBold True
    '            Case False
    '                PrintFontBold False
    '        End Select
    '        Select Case ssReportRecords.Underline
    '            Case True
    '                'PrintFontUnderline True
    '                Printer.FontUnderline = True
    '            Case False
    '                'PrintFontUnderline False
    '                Printer.FontUnderline = False
    '        End Select
            
            If ssReportRecords.RightJustify Then
                PrintRightJustify sPart1
            End If
            If bPageBreak Then
                bPageBreak = False
                Printer.NewPage
            End If
            If ssReportRecords.PageBreak Then
                'Do it if there is another line to print
                bPageBreak = True
            End If
            PrintFontBold ssReportRecords.Bold
            PrintFontUnderline ssReportRecords.Underline
            Select Case True
                Case ssReportRecords.Tab2 > 0
                    PrintPrint sPart1, _
                               ssReportRecords.Tab1, _
                               ssReportRecords.linepart2, _
                               ssReportRecords.Tab2, _
                               ssReportRecords.Linepart3
                Case ssReportRecords.Tab1 > 0
                    PrintPrint sPart1, _
                               ssReportRecords.Tab1, _
                               ssReportRecords.linepart2
                Case Else
                    PrintPrint sPart1
            End Select
            'bOldBold = ssReportRecords.Bold
            'bOldUnderline = ssReportRecords.Underline
            'bPrintedFirstLine = True
        End If
        ssReportRecords.MoveNext
    Loop
    
    Printer.EndDoc
    ssReportRecords.Close
    
'ErrorRoutine:

    'If Err.Number <> 0 Then DisplayError "GetLanguages"

End Sub

Public Sub DeleteOldReport()
    
    Dim SQL As String
    
    SQL = "DELETE FROM Report"
    gdbStoreData.Execute SQL, dbFailOnError

End Sub

Public Sub DisplayFileTypes()

    Dim nIndex As Integer
    Dim nIndex2 As Integer
    Dim sLine As String
    Dim nPos As Integer
    Dim sFileType As String
    Dim bFound As Boolean
    
    On Error GoTo ErrorRoutine
    
    frmFiles.lstFileType.Clear
    
    For nIndex = 0 To frmProject.lstModules.ListCount - 1
        If frmProject.lstModules.Selected(nIndex) Then
            Open frmProject.lstModules.Text For Input As #1
            Do Until EOF(1)
                Line Input #1, sLine
                sLine = LTrim(sLine)
                If Left(sLine, 9) = "SOURCE=.\" Then
                '******* 01.01.01 Misc #2 Start *******
'                    sFileType = ""
'                    For nPos = Len(sLine) To 1 Step -1
'                        If Mid(sLine, nPos, 1) = "." Then
'                            bFound = False
'                            For nIndex2 = 0 To frmFiles.lstFileType.ListCount - 1
'                                If sFileType = frmFiles.lstFileType.List(nIndex2) Then
'                                    bFound = True
'                                    Exit For
'                                End If
'                            Next
'                            If Not bFound Then
'                                frmFiles.lstFileType.AddItem sFileType
'                            End If
'                            Exit For
'                        Else
'                            sFileType = Mid(sLine, nPos, 1) & sFileType
'                        End If
'                    Next
                    sFileType = UCase(GetExtension(sLine))
                    bFound = False
                    For nIndex2 = 0 To frmFiles.lstFileType.ListCount - 1
                        If sFileType = frmFiles.lstFileType.List(nIndex2) Then
                            bFound = True
                            Exit For
                        End If
                    Next
                    If Not bFound Then
                        frmFiles.lstFileType.AddItem sFileType
                    End If
                '******* 01.01.01 Misc #2 End *********
                End If
            Loop
            Close #1
        End If
    Next
    
    For nIndex = 0 To frmFiles.lstFileType.ListCount - 1
        bFound = False
        For nIndex2 = 0 To frmExtension.lstExtensions.ListCount - 1
            If frmFiles.lstFileType.List(nIndex) = _
               frmExtension.lstExtensions.List(nIndex2) Then
                bFound = True
            End If
        Next
        If Not bFound Then
            frmFiles.lstFileType.Selected(nIndex) = True
        End If
    Next
    
    Exit Sub
    
ErrorRoutine:

    DisplayError "DisplayFileTypes"
    
End Sub

Public Function CountLinesC(sName As String) As Double

    Dim sLine As String
    Dim bLongComment As Boolean
    Dim dProcedureCount As Double
    Const COMMENT_1Line = "//"
    Const COMMENT_START = "/*"
    Const COMMENT_END = "*/"
    Const COL2 = 5
    
    Open gsProjectPath & sName For Input As #2
    frmProject.lblCounting.Caption = "Counting " & sName & "..."
    DoEvents
    
    Do Until EOF(2)
        Line Input #2, sLine
        sLine = Trim(sLine)
        'get rid of leading ASC 9 characters
        If Len(sLine) > 0 Then
            Do Until Asc(Mid(sLine, 1, 1)) <> 9
                sLine = Mid(sLine, 2, Len(sLine))
                If Len(sLine) = 0 Then
                    Exit Do
                End If
            Loop
        End If
        Select Case True
            Case Len(sLine) = 0
                'Ignore blank lines
            Case InStr(sLine, COMMENT_END)
                bLongComment = False
                If gbIncludeComments Then
                    dProcedureCount = dProcedureCount + 1
                    gdTotalCount = gdTotalCount + 1
                End If
            Case InStr(sLine, COMMENT_START)
                If gbIncludeComments Then
                    dProcedureCount = dProcedureCount + 1
                    gdTotalCount = gdTotalCount + 1
                Else
                    bLongComment = True
                    If Left(sLine, 2) <> COMMENT_START Then
                        dProcedureCount = dProcedureCount + 1
                        gdTotalCount = gdTotalCount + 1
                    End If
                End If
            Case bLongComment
                'Ignore these lines until the ending comment is found
            Case Left(sLine, 2) = COMMENT_1Line
                'Count comment lines if that option is chosen
                If gbIncludeComments Then
                    dProcedureCount = dProcedureCount + 1
                    gdTotalCount = gdTotalCount + 1
                End If
            Case sLine = "{"
                'MsgBox sLine
            Case sLine = "}"
                'MsgBox sLine
            Case Else
                dProcedureCount = dProcedureCount + 1
                gdTotalCount = gdTotalCount + 1
                'Debug.Print sLine
        End Select
    Loop
    
    Close #2
    
    CountLinesC = dProcedureCount

End Function
Public Function ProcessDSW() As Boolean

    Dim nModuleIndex As Integer
    Dim nAllIndex As Integer
    Dim dProcedureCount As Double
    Dim dModuleCount As Double
    Dim rsReport As Recordset
    Dim nResponse As Integer
    Dim sMsg As String
    Dim bModNamePrinted As Boolean
    
    On Error GoTo ErrorRoutine
    
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)
    
    'Get the file types from all the DSP modules selected
    DisplayFileTypes
    
    'Position the list of files just above (or below) the DSP list
    frmFiles.Top = frmProject.Top - frmFiles.Height + frmProject.lstModules.Top
    If frmFiles.Top < 0 Then
        frmFiles.Top = frmProject.Top + frmProject.Height - 1000
    End If
    
    'Show the form that lists the files
    Screen.MousePointer = vbNormal
    frmProject.cmdCount.Enabled = False
    frmProject.Enabled = False
    frmFiles.lstFileType.ListIndex = -1
    frmFiles.Show 1
    frmProject.cmdCount.Enabled = True
    frmProject.Enabled = True
    Screen.MousePointer = vbHourglass
            
    PrintHeading rsReport
    
    'Fill the invisible list with all the files that have file types
    'that are in the file type list
    For nModuleIndex = 0 To frmProject.lstModules.ListCount - 1
        If frmProject.lstModules.Selected(nModuleIndex) Then
            dModuleCount = 0
            frmProject.lstModules.ListIndex = nModuleIndex
            frmProject.lstAllDSPMod.Clear
            bModNamePrinted = False
            GetAllModulesDSP (frmProject.lstModules.List(nModuleIndex))
            'Count the lines in all the modules that are in the invisible list
            For nAllIndex = 0 To frmProject.lstAllDSPMod.ListCount - 1
                If gbQuit Then
                    rsReport.Close
                    ProcessDSW = True
                    Exit Function
                End If
                frmProject.lstAllDSPMod.ListIndex = nAllIndex
                dProcedureCount = CountLinesC(frmProject.lstAllDSPMod.Text)
                dModuleCount = dModuleCount + dProcedureCount
                If gbReportDetails Then
                    bModNamePrinted = WriteProcedureStats(rsReport, bModNamePrinted, frmProject.lstAllDSPMod.Text, dProcedureCount, dProcedureCount)
                End If
SkipFile:
            Next
            bModNamePrinted = WriteModuleStats(rsReport, bModNamePrinted, frmProject.lstAllDSPMod.Text, dProcedureCount, dModuleCount)
        End If
    Next
    
    If Not gbReportDetails Then
    End If
    
    PrintFinish rsReport

    ProcessDSW = True
    Exit Function
ErrorRoutine:

    If Err.Number = 53 Or Err.Number = 76 Then '53 = file not found, 76 = path not found
        Beep
        Beep
        sMsg = "File " & frmProject.lstAllDSPMod.Text & " not found." _
             & vbCrLf & vbCrLf _
             & "Press OK to ignore the missing file and continue counting."
        nResponse = MsgBox(sMsg, vbCritical + vbOKCancel, "Missing File")
        If nResponse = vbCancel Then
            ProcessDSW = False
            Exit Function
        Else
'            If gbReportDetails Then
'                PrintPrint frmProject.lstAllDSPMod.Text & " - Not Found"
'                StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
'                           frmProject.lstAllDSPMod.Text & " - Not Found"
'            End If
            Resume SkipFile
        End If
    Else
        DisplayError "ProcessDSW"
    End If

End Function

Public Sub OldProcessDSW()

    Dim nModuleIndex As Integer
    Dim dProcedureCount As Double
    Dim rsReport As Recordset
    Dim nResponse As Integer
    Dim sMsg As String
    
    On Error GoTo ErrorRoutine
    
    Set rsReport = gdbStoreData.OpenRecordset("Report", dbOpenDynaset)
    
    'Get the file types from all the DSP modules selected
    DisplayFileTypes
    
    'Position the list of files just above (or below) the DSP list
    frmFiles.Top = frmProject.Top - frmFiles.Height + frmProject.lstModules.Top
    If frmFiles.Top < 0 Then
        frmFiles.Top = frmProject.Top + frmProject.Height - 1000
    End If
    
    'Show the form that lists the files
    Screen.MousePointer = vbNormal
    frmProject.cmdCount.Enabled = False
    frmProject.Enabled = False
    frmFiles.lstFileType.ListIndex = -1
    frmFiles.Show 1
    frmProject.cmdCount.Enabled = True
    frmProject.Enabled = True
    Screen.MousePointer = vbHourglass
            
    'Fill the invisible list with all the files that have file types
    'that are in the file type list
    frmProject.lstAllDSPMod.Clear
    For nModuleIndex = 0 To frmProject.lstModules.ListCount - 1
        If frmProject.lstModules.Selected(nModuleIndex) Then
            GetAllModulesDSP (frmProject.lstModules.List(nModuleIndex))
        End If
    Next
    
    PrintHeading rsReport
    
    'Count the lines in all the modules that are in the invisible list
    For nModuleIndex = 0 To frmProject.lstAllDSPMod.ListCount - 1
        If gbQuit Then
            rsReport.Close
            Exit Sub
        End If
        frmProject.lstAllDSPMod.ListIndex = nModuleIndex
        dProcedureCount = CountLinesC(frmProject.lstAllDSPMod.Text)
        If gbReportDetails Then
            PrintPrint frmProject.lstAllDSPMod.Text & ";"
            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                       frmProject.lstAllDSPMod.Text & ";"
            PrintPrint "", COL3, dProcedureCount
            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                       "", COL3, dProcedureCount
        End If
SkipFile:
    Next
    
    If Not gbReportDetails Then
    End If
    
    PrintFinish rsReport

    Exit Sub
ErrorRoutine:

    If Err.Number = 53 Or Err.Number = 76 Then '53 = file not found, 76 = path not found
        Beep
        Beep
        sMsg = "File " & frmProject.lstAllDSPMod.Text & " not found." _
             & vbCrLf & vbCrLf _
             & "Press OK to ignore the missing file and continue counting."
        nResponse = MsgBox(sMsg, vbCritical + vbOKCancel, "Missing File")
        If nResponse = vbCancel Then
            End
        Else
            PrintPrint frmProject.lstAllDSPMod.Text & " - Not Found"
            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                       frmProject.lstAllDSPMod.Text & " - Not Found"
            Resume SkipFile
        End If
    Else
        DisplayError "ProcessDSW"
    End If

End Sub

Public Sub PrintHeading(rsReport As Recordset)
    
    PrintFontBold True
    PrintFontUnderline True
    PrintPrint "Line Count Results for " & gsProject
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               "Line Count Results for " & gsProject
    
    PrintPrint ""
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               ""
    PrintPrint "Name", COL3 + 1, "Lines"
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               "Name", COL3 + 1, "Lines"
    PrintFontBold False
    PrintFontUnderline False

End Sub

Public Sub PrintFinish(rsReport As Recordset)

    Dim bPagePrinted As Boolean

    PrintPrint ""
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               ""
    PrintFontBold True
    PrintPrint "Total", COL3, gdTotalCount
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                "Total", COL3, gdTotalCount
    PrintPrint ""
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               ""
    PrintPrint ""
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               ""
    PrintFontUnderline True
    PrintPrint "Options in Effect"
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               "Options in Effect"
    PrintFontUnderline False
    PrintFontBold False
    PrintPrint StripAmpersand(frmProject.mnuDetails.Caption), COL3, YesNo(frmProject.mnuDetails.Checked)
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               StripAmpersand(frmProject.mnuDetails.Caption), COL3, YesNo(frmProject.mnuDetails.Checked)
    PrintPrint StripAmpersand(frmProject.mnuComments.Caption), COL3, YesNo(frmProject.mnuComments.Checked)
    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
               StripAmpersand(frmProject.mnuComments.Caption), COL3, YesNo(frmProject.mnuComments.Checked)
'    PrintPrint StripAmpersand(frmProject.mnuDims.Caption), COL3 , YesNo(frmProject.mnuDims.Checked)
'    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
'               StripAmpersand(frmProject.mnuDims.Caption), COL3 , YesNo(frmProject.mnuDims.Checked)
    'If gbReportDetails Then
        PrintPrint StripAmpersand(frmProject.mnuZero.Caption), COL3, YesNo(frmProject.mnuZero.Checked)
        StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                   StripAmpersand(frmProject.mnuZero.Caption), COL3, YesNo(frmProject.mnuZero.Checked)
    'End If
    
    'Fill the bottom of the page with blank lines
    If frmResults.picPreview(gnPageNumber).CurrentY + 300 <= Printer.ScaleHeight Then
        Do Until bPagePrinted
            bPagePrinted = PrintPrint("")
            If bPagePrinted Then Exit Do 'So a last blank line isn't saved to the database
            StoreReportLine rsReport, gbBold, gbUnderline, False, False, ""
        Loop
    End If
    '1 is subtracted because a new picture has been generated automatically
    'after a new page is printed
    gnPageNumber = gnPageNumber - 1
    frmResults.picPreview(gnPageNumber).Height = _
            frmResults.picPreview(gnPageNumber).CurrentY + 300

End Sub

Public Sub DSPWarning()

    Dim sCaption As String
    Dim nPos As Integer
    Dim sTitle As String
    Dim sMsg As String
    Dim nStyle As Integer
    
    nPos = InStr(frmProject.mnuDetails.Caption, "&")
    sCaption = Left(frmProject.mnuDetails.Caption, nPos - 1) & Mid(frmProject.mnuDetails.Caption, nPos + 1, Len(frmProject.mnuDetails.Caption))
    sTitle = "Report Warning"
    nStyle = vbInformation
    sMsg = "Selecting " & sCaption _
         & " has no effect when a C++ project file is chosen."
    MsgBox sMsg, nStyle, sTitle

End Sub


Public Function WriteModuleStats(rsReport As Recordset, bModNamePrinted As Boolean, sProcedureName As String, dProcedureCount As Double, dModuleCount As Double) As Boolean

        If Not bModNamePrinted Then
            bModNamePrinted = True
            If gbReportDetails Then
                If gbReportZero Then
                    PrintPrint frmProject.lstModules.Text
                    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                               frmProject.lstModules.Text
                    PrintPrint "", COL2, sProcedureName, COL3, dProcedureCount
                    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                               "", COL2, sProcedureName, COL3, dProcedureCount
                Else
                    If dModuleCount > 0 Then
                        PrintPrint frmProject.lstModules.Text
                        StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                                   frmProject.lstModules.Text
                    End If
                    If dProcedureCount > 0 Then
                        PrintPrint "", COL2, sProcedureName, COL3, dProcedureCount
                        StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                                   "", COL2, sProcedureName, COL3, dProcedureCount
                    End If
                End If
            Else
                If gbReportZero Then
                    PrintPrint frmProject.lstModules.Text & ";"
                    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                               frmProject.lstModules.Text & ";"
                    PrintPrint "", COL3, dModuleCount
                    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                               "", COL3, dModuleCount
                    Else
                        If dModuleCount > 0 Then
                            PrintPrint "", COL3, dModuleCount
                            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                                       "", COL3, dModuleCount
                        End If
                End If
            End If
        End If
        
        WriteModuleStats = bModNamePrinted

End Function

Public Function WriteProcedureStats(rsReport As Recordset, bModNamePrinted As Boolean, sProcedureName As String, dModuleCount As Double, dProcedureCount As Double) As Boolean

    Dim nCol As Integer

    If gnModuleType = DSP Then
        nCol = 0
    Else
        nCol = COL2
    End If
    
    If gbReportDetails Then
        If gbReportZero Then
            If Not bModNamePrinted Then
                bModNamePrinted = True
                PrintPrint frmProject.lstModules.Text
                StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                           frmProject.lstModules.Text
            End If
            PrintPrint "", nCol, sProcedureName, COL3, dProcedureCount
            StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                       "", nCol, sProcedureName, COL3, dProcedureCount
        Else
            If Not bModNamePrinted Then
                bModNamePrinted = True
                If dModuleCount > 0 Then
                    PrintPrint frmProject.lstModules.Text
                    StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                               frmProject.lstModules.Text
                End If
            End If
            If dProcedureCount > 0 Then
                PrintPrint "", nCol, sProcedureName, COL3, dProcedureCount
                StoreReportLine rsReport, gbBold, gbUnderline, False, False, _
                           "", nCol, sProcedureName, COL3, dProcedureCount
           End If
        End If
    End If
    
    WriteProcedureStats = bModNamePrinted

End Function

Public Function GetExtension(sFileName As String) As String

    '******* 01.01.01 Misc #2 Start *******
    Dim sExt As String
    Dim nPos As Integer
    
    sExt = ""
    For nPos = Len(sFileName) To 1 Step -1
        If Mid(sFileName, nPos, 1) = "." Then
            GetExtension = sExt
            Exit Function
        Else
            sExt = Mid(sFileName, nPos, 1) & sExt
        End If
    Next
    
    GetExtension = ""
    '******* 01.01.01 Misc #2 End *********

End Function
